/**
 * 
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.relatorios;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import javax.sql.DataSource;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Datebox;
import org.zkoss.zul.Radiogroup;
import org.zkoss.zul.Row;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.relatorios.impl.RelatorioAproveitamentoFinanceiro;
import com.rjconsultores.ventaboletos.relatorios.impl.RelatorioAproveitamentoFinanceiroTrecho;
import com.rjconsultores.ventaboletos.relatorios.utilitarios.Relatorio;
import com.rjconsultores.ventaboletos.service.RutaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.vo.ruta.RutaVO;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxEstandar;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderRelatorioAproveitamentoFinanceiro;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderRelatorioAproveitamentoFinanceiroTrecho;


@Controller("relatorioAproveitamentoFinanceiroController")
@Scope("prototype")
@SuppressWarnings({ "rawtypes", "unchecked" })

public class RelatorioAproveitamentoFinanceiroController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	private static Logger log = Logger.getLogger(RelatorioAproveitamentoFinanceiroController.class);

	@Autowired
	private DataSource dataSourceRead;

	private Datebox datInicial;
	private Datebox datFinal;
	private MyComboboxEstandar cmbEmpresa;
	private List<Empresa> lsEmpresa;	
	private ArrayList<RutaVO> rutaVO = new ArrayList<RutaVO>();
	@Autowired
	private RutaService rutaService;

	private MyListbox linhaList;
	private MyListbox trechoList;
	private MyListbox linhaListSelList;
	private Textbox txtPalavraPesquisaLinha;
	private ArrayList<Ruta> lsNumLinha = new ArrayList<Ruta>();
	private Radiogroup rgLayout;
	private Row rowTrecho;
	private Map<Integer, List<RutaVO>> mapRutaTrecho = new HashMap<>();

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		lsEmpresa = UsuarioLogado.getUsuarioLogado().getEmpresa();
		linhaList.setItemRenderer(new RenderRelatorioAproveitamentoFinanceiro());
		linhaListSelList.setItemRenderer(new RenderRelatorioAproveitamentoFinanceiro());
		trechoList.setItemRenderer(new RenderRelatorioAproveitamentoFinanceiroTrecho());
		
	}
	
	public void carregarTramos(Ruta rutaSelecionada) {
		
		List<RutaVO> lsRutaVO = rutaService.buscaRutaParadas(rutaSelecionada.getRutaId());
		RutaVO ultimaRuta = lsRutaVO.get(lsRutaVO.size()-1);
		RutaVO novaRuta = new RutaVO(ultimaRuta.getRutaId(), ultimaRuta.getNumRuta(), ultimaRuta.getPrefixo(),ultimaRuta.getDescruta(),ultimaRuta.getDescDestino(), ultimaRuta.getNumSecuencia(), ultimaRuta.getDestinoId(), ultimaRuta.getDestinoId());
		novaRuta.setDescOrigem(novaRuta.getDescParada());
		lsRutaVO.add(novaRuta);

		mapRutaTrecho.put(rutaSelecionada.getRutaId(), lsRutaVO);
		List<RutaVO> lsRutaVOAux = new ArrayList();
		lsRutaVOAux.addAll(trechoList.getListData());
		lsRutaVOAux.addAll(lsRutaVO);
		trechoList.setData(lsRutaVOAux);
		
		
	}
	
	public void actualizarDados(List<RutaVO> listaRutaVO) {
		
	}

	public List<Empresa> getLsEmpresa() {
		return lsEmpresa;
	}

	public void setLsEmpresa(List<Empresa> lsEmpresa) {
		this.lsEmpresa = lsEmpresa;
	}

	public void onDoubleClick$linhaList(Event ev) {
		Ruta rutaAux = (Ruta) linhaList.getSelected();
		linhaListSelList.addItemNovo(rutaAux);
		carregarTramos(rutaAux);
	}

	private void executarPesquisaLinha() {

		String palavraPesquisaRuta = txtPalavraPesquisaLinha.getText();
		linhaList.setData(rutaService.buscaRuta(palavraPesquisaRuta));
		
		if (linhaList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("relatorioLinhasHorarioController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
				log.error(ex);
			}
		}
	}

	public void onClick$btnPesquisaLinha(Event ev) {
		executarPesquisaLinha();
	}

	public void onClick$btnLimparLinha(Event ev) {
		linhaList.clearSelection();
		lsNumLinha.clear();
	}

	public void onClick$btnExecutarRelatorio(Event ev) throws Exception {
		executarRelatorio();
	}

	private void executarRelatorio() throws Exception {
		
		if(rgLayout.getSelectedItem().getValue().equals("EMISSAO_LINHA")) {
			executarRelatorioLinha();
		}else {
			executarRelatorioTrecho();
		}		
	}
	
	private void executarRelatorioLinha() throws Exception {

		Map<String, Object> parametros = new HashMap<String, Object>();
		StringBuilder filtro = new StringBuilder();

		filtro.append("Linha: ");
		String linhaIds = "";
		String linhas = "";
		List<Ruta> lslinhaSelecionados = new ArrayList(Arrays.asList(linhaListSelList.getData()));
		if (lslinhaSelecionados.isEmpty()) {
			linhas = "Todas";
		} else {
			for (int i = 0; i < lslinhaSelecionados.size(); i++) {
				Ruta linha = lslinhaSelecionados.get(i);
				linhas = linhas + linha.getDescruta() + ", ";

				linhaIds = linhaIds + linha.getRutaId() + ", ";
			}

			// removendo ultima virgula
			linhaIds = linhaIds.substring(0, linhaIds.length() - 2);
			linhas = linhas.substring(0, linhas.length() - 2);
			parametros.put("LINHAS", linhaIds);
		}
		filtro.append(linhas).append(";");
		
		parametros.put("DATA_INICIAL", (java.util.Date) this.datInicial.getValue());
		parametros.put("DATA_FINAL", (java.util.Date) this.datFinal.getValue());
		parametros.put("NOME_RELATORIO", Labels.getLabel("relatorioAproveitamentoFinanceiroController.window.title"));
		parametros.put("USUARIO", UsuarioLogado.getUsuarioLogado().getNombusuario());
		

		filtro.append(" Empresa: ");

		Comboitem itemEmpresa = cmbEmpresa.getSelectedItem();
		if (itemEmpresa != null) {
			Empresa empresa = (Empresa) itemEmpresa.getValue();
			parametros.put("EMPRESA_ID", empresa.getEmpresaId());
			parametros.put("EMPRESA", empresa.getNombempresa());
			filtro.append(empresa.getNombempresa() + ";");
		} else {
			filtro.append(" Todas;");
		}

		parametros.put("FILTROS", filtro.toString());
		Relatorio relatorio = new RelatorioAproveitamentoFinanceiro(parametros, dataSourceRead.getConnection());

		Map args = new HashMap();
		args.put("relatorio", relatorio);

		openWindow("/component/reportView.zul",
				Labels.getLabel("relatorioAproveitamentoFinanceiroController.window.title"), args, MODAL);
	}
	private void executarRelatorioTrecho() throws Exception {
		
		Map<String, Object> parametros = new HashMap<String, Object>();
		StringBuilder filtro = new StringBuilder();
		List<RutaVO>lista = new ArrayList<>();
		Map<Integer, List<RutaVO>> mapRutaTrechoAux = new HashMap<>();
		
		for (Entry<Integer, List<RutaVO>> entry : mapRutaTrecho.entrySet()) {			
			List<RutaVO> listaAux =  entry.getValue();			
				for (RutaVO rutaVO2 : (List<RutaVO>)trechoList.getListData()) {
					for (RutaVO rutaVO : listaAux) {
						if(rutaVO.getRutaId().equals(rutaVO2.getRutaId())) {
							lista.add(rutaVO2);
							break;
						}
					}
				}
				mapRutaTrechoAux.put(entry.getKey(), lista);
				lista = new ArrayList<>();
			}
		
		filtro.append("Linha: ");
		String linhaIds = "";
		String linhas = "";
		List<Ruta> lslinhaSelecionados = new ArrayList(Arrays.asList(linhaListSelList.getData()));
		if (lslinhaSelecionados.isEmpty()) {
			linhas = "Todas";
		} else {
			for (int i = 0; i < lslinhaSelecionados.size(); i++) {
				Ruta linha = lslinhaSelecionados.get(i);
				linhas = linhas + linha.getDescruta() + ", ";

				linhaIds = linhaIds + linha.getRutaId() + ", ";
			}

			// removendo ultima virgula
			linhaIds = linhaIds.substring(0, linhaIds.length() - 2);
			linhas = linhas.substring(0, linhas.length() - 2);
			parametros.put("LINHAS", linhaIds);
		}
		filtro.append(linhas).append(";");
		
		parametros.put("DATA_INICIAL", (java.util.Date) this.datInicial.getValue());
		parametros.put("DATA_FINAL", (java.util.Date) this.datFinal.getValue());
		parametros.put("NOME_RELATORIO", Labels.getLabel("relatorioAproveitamentoFinanceiroController.window.title"));
		parametros.put("USUARIO", UsuarioLogado.getUsuarioLogado().getNombusuario());
		parametros.put("TRECHOS", trechoList.getListData());
		parametros.put("MAPRUTATRECHO", mapRutaTrechoAux);

		filtro.append(" Empresa: ");

		Comboitem itemEmpresa = cmbEmpresa.getSelectedItem();
		if (itemEmpresa != null) {
			Empresa empresa = (Empresa) itemEmpresa.getValue();
			parametros.put("EMPRESA_ID", empresa.getEmpresaId());
			parametros.put("EMPRESA", empresa.getNombempresa());
			filtro.append(empresa.getNombempresa() + ";");
		} else {
			filtro.append(" Todas;");
		}

		parametros.put("FILTROS", filtro.toString());
		Relatorio relatorio = new RelatorioAproveitamentoFinanceiroTrecho(parametros, dataSourceRead.getConnection());

		Map args = new HashMap();
		args.put("relatorio", relatorio);

		openWindow("/component/reportView.zul",
				Labels.getLabel("relatorioAproveitamentoFinanceiroController.window.title"), args, MODAL);
	}
	
}
